//----------------------------------------------------------------
//Code Art.
//
//ļ:
//
//  : jianyi0115@163.com
//: 2008-1-19
//
//޶¼: 
//
//----------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Collections;
using System.ComponentModel;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using Microsoft.SharePoint;
using CodeArt.SharePoint;

namespace CodeArt.SharePoint.WebParts
{

    [Serializable]
    public class FieldEditSetting
    {
        public string FieldName;

        public bool CreatorCanEdit;

        public bool AllUserCanEdit;

        public string SpecialAccounts;

        public string SpecialGroups;

        private StringCollection _GroupCollections;

        public bool IsInSpecialAccounts(string account)
        {
            if (String.IsNullOrEmpty(SpecialAccounts))
                return false;

            string checkList = "," + this.SpecialAccounts.ToLower() + ",";

            return checkList.IndexOf("," + account.ToLower() + ",") != -1;
        }

        public bool IsInSpecialGroups(SPUser currentUser)
        {
            if (String.IsNullOrEmpty(SpecialGroups))
                return false;

            if (_GroupCollections == null)
            {
                _GroupCollections = new StringCollection();
                _GroupCollections.AddRange(SpecialGroups.Split(','));
            }

            foreach (SPGroup g in currentUser.Groups)
            {
                if (_GroupCollections.Contains(g.Name))
                    return true;
            }

            return false;
        }

        public bool CanEdit(SPUser currentUser, SPUser creatUser)
        {
            //if (currentUser.IsSiteAdmin) return true;

            if (this.AllUserCanEdit) return true;

            if (this.CreatorCanEdit && String.Compare(currentUser.LoginName, creatUser.LoginName, true) == 0)
                return true;

            bool inAccounts = this.IsInSpecialAccounts(currentUser.LoginName);

            if (inAccounts)
                return true;

            return this.IsInSpecialGroups(currentUser);
        }
    }

    /// <summary>
    /// бֶα༭Ȩô洢
    /// </summary>
    [Serializable]
    public class ListFieldEditSetting : List<FieldEditSetting> // Dictionary<string,FieldEditSetting>
    {
        public const string Config_List = "__ListFieldEditControlConfig";

        public FieldEditSetting GetByFieldName(string fieldName)
        {
            foreach (FieldEditSetting fSetting in this)
            {
                if (String.Compare(fSetting.FieldName, fieldName, true) == 0)
                    return fSetting;
            }

            return null;
        }

        public void Save(Guid listId)
        {
            ConfigManager cmg = ConfigManager.GetConfigManager(ListFieldEditSetting.Config_List);
            cmg.SetConfigData(listId, this);
        }        

        public static ListFieldEditSetting GetListSetting(Guid listId)
        {
            ConfigManager cmg = ConfigManager.GetConfigManager(ListFieldEditSetting.Config_List);

            ListFieldEditSetting setting = cmg.GetConfigData<ListFieldEditSetting>(listId);

            return setting;
        }
    }

    /// <summary>
    /// бֶα༭Ȩÿؼ
    /// </summary>
    public class FieldRightSettingPart : BaseSPListWebPart
    {
        private Button _btnSubmit;
        private Table _layoutTable;

        private Dictionary<string, CheckBox> _AllUserCanEditControls = new Dictionary<string, CheckBox>();
        private Dictionary<string, CheckBox> _CreatorCanEditControls = new Dictionary<string, CheckBox>();
        private Dictionary<string, Microsoft.SharePoint.WebControls.PeopleEditor> _SpecialAccountsControls =
        new Dictionary<string, Microsoft.SharePoint.WebControls.PeopleEditor>();

        private Dictionary<string, Microsoft.SharePoint.WebControls.PeopleEditor> _SpecialGroupsControls =
        new Dictionary<string, Microsoft.SharePoint.WebControls.PeopleEditor>();

        protected override void CreateChildControls()
        {
            if (List == null)
                return;

            _layoutTable = new Table();
            _layoutTable.BorderWidth = new Unit("0px");
            _layoutTable.CssClass = "ms-formtable";
            _layoutTable.CellSpacing = 0;

            this.Controls.Add(_layoutTable);
            this.AddRow(_layoutTable, "<b>ֶ</b>", "<b>༭Ȩ</b>");

            //
            ConfigManager cmg = ConfigManager.GetConfigManager(ListFieldEditSetting.Config_List);

            ListFieldEditSetting setting = cmg.GetConfigData<ListFieldEditSetting>(List.ID);

            //
            foreach (SPField f in List.Fields)
            {
                if (f.Hidden || f.ReadOnlyField) continue;

                TableRow row = new TableRow();
                _layoutTable.Rows.Add(row);
                TableCell fieldCell = new TableCell();
                fieldCell.VerticalAlign = VerticalAlign.Top;
                fieldCell.CssClass = "ms-formlabel";
                row.Cells.Add(fieldCell);

                fieldCell.Text = f.Title + f.AuthoringInfo;

                TableCell ctlCell = new TableCell();
                ctlCell.VerticalAlign = VerticalAlign.Top;
                ctlCell.CssClass = "ms-formbody";
                row.Cells.Add(ctlCell);

                CheckBox allUser = new CheckBox();
                allUser.Text = "Ա";
                allUser.Checked = true;
                ctlCell.Controls.Add(allUser);
                this.AddHtml("<br/>", ctlCell);

                _AllUserCanEditControls.Add(f.InternalName, allUser);

                CheckBox creator = new CheckBox();
                creator.Text = "";
                creator.Checked = true;
                ctlCell.Controls.Add(creator);
                this.AddHtml("<br/>", ctlCell);

                _CreatorCanEditControls.Add(f.InternalName, creator);

                //public enum AccountType
                //{
                //    User = 0,
                //    DL = 1,
                //    SecGroup = 2,
                //    SPGroup = 3,
                //}

                this.AddHtml("ָԱ<br/>", ctlCell);
                Microsoft.SharePoint.WebControls.PeopleEditor peopleEditor = new Microsoft.SharePoint.WebControls.PeopleEditor();
                peopleEditor.MultiSelect = true;
                peopleEditor.Rows = 1;
                peopleEditor.Width = new Unit("300px");

                peopleEditor.SelectionSet = "User";//"User,SPGroup";
                ctlCell.Controls.Add(peopleEditor);

                _SpecialAccountsControls.Add(f.InternalName, peopleEditor);

                this.AddHtml("<br/>ָ飺<br/>", ctlCell);
                Microsoft.SharePoint.WebControls.PeopleEditor peopleEditor2 = new Microsoft.SharePoint.WebControls.PeopleEditor();
                peopleEditor2.MultiSelect = true;
                peopleEditor2.Rows = 1;
                peopleEditor2.Width = new Unit("300px");

                peopleEditor2.SelectionSet = "SPGroup";
                ctlCell.Controls.Add(peopleEditor2);

                _SpecialGroupsControls.Add(f.InternalName, peopleEditor2);

                this.SetControlValue(allUser, creator, peopleEditor, peopleEditor2, setting, f.InternalName);
            }

            _btnSubmit = new Button();
            _btnSubmit.ID = "btn1";
            _btnSubmit.Text = "ȷ";
            _btnSubmit.CssClass = "ms-ButtonHeightWidth";
            this.Controls.Add(_btnSubmit);
            _btnSubmit.Click += new EventHandler(_btnSubmit_Click);

        }

        void SetControlValue(CheckBox allUser, CheckBox creator, Microsoft.SharePoint.WebControls.PeopleEditor peopleEditor,
            Microsoft.SharePoint.WebControls.PeopleEditor peopleEditor2, ListFieldEditSetting setting, string fieldName)
        {
            if (setting == null || setting.Count == 0 || Page.IsPostBack)
                return;

            FieldEditSetting set = setting.GetByFieldName(fieldName);

            if (set == null) return;

            allUser.Checked = set.AllUserCanEdit;
            creator.Checked = set.CreatorCanEdit;
            peopleEditor.CommaSeparatedAccounts = set.SpecialAccounts;
            peopleEditor2.CommaSeparatedAccounts = set.SpecialGroups;
        }


        void _btnSubmit_Click(object sender, EventArgs e)
        {
            ListFieldEditSetting setting = new ListFieldEditSetting();

            foreach (SPField f in List.Fields)
            {
                if (f.Hidden || f.ReadOnlyField) continue;

                FieldEditSetting set = new FieldEditSetting();
                setting.Add(set);

                set.FieldName = f.InternalName.ToLower();

                CheckBox allUser = _AllUserCanEditControls[f.InternalName];

                set.AllUserCanEdit = allUser.Checked;

                CheckBox creator = _CreatorCanEditControls[f.InternalName];

                set.CreatorCanEdit = creator.Checked;

                Microsoft.SharePoint.WebControls.PeopleEditor peopleEditor = _SpecialAccountsControls[f.InternalName];

                set.SpecialAccounts = peopleEditor.CommaSeparatedAccounts;

                set.SpecialGroups = _SpecialGroupsControls[f.InternalName].CommaSeparatedAccounts;
            }

            setting.Save(base.List.ID);

            if (Page.Request.QueryString["ListId"] != null)
            {
                string webUrl = base.Web.ServerRelativeUrl;
                if (!webUrl.EndsWith("/"))
                    webUrl += "/";

                string sourceUrl = webUrl + "_layouts/listedit.aspx?List=" + base.List.ID.ToString("B").ToUpper();
                Page.Response.Redirect(sourceUrl);
            }
        }

        //void AddRow( Table table , params Control[] ctls)
        //{
        //    TableRow row = new TableRow();
        //    table.Rows.Add(row);

        //    foreach (Control c in ctls)
        //    {
        //        TableCell cell = new TableCell();
        //        row.Cells.Add(cell);
        //        cell.Controls.Add(c);
        //    }
        //}

        void AddRow(Table table, params string[] texts)
        {
            TableRow row = new TableRow();
            table.Rows.Add(row);

            foreach (string c in texts)
            {
                TableCell cell = new TableCell();
                row.Cells.Add(cell);
                cell.Text = c;
            }
        }
    }
}
