﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        ObjectDataSource odsDataSource = new ObjectDataSource();
        odsDataSource.ID = "ExampleSource";
        odsDataSource.TypeName = this.GetType().FullName + "," + this.GetType().Assembly.FullName;
        odsDataSource.SelectMethod = "GetDataTable";
        Controls.Add(odsDataSource);

        //if (Page.IsPostBack)
        //    return;

        //{0}表示过滤值，{1}表示过滤字段值
        SPGridView1.FilteredDataSourcePropertyFormat = "{1}='{0}'";
        SPGridView1.FilteredDataSourcePropertyName = "FilterExpression" ;    

        SPGridView1.EnableViewState = true;

        //添加字段
        SPBoundField col = new SPBoundField();
        col.DataField = "Title";
        col.SortExpression = "Title";
        col.HeaderText = "Title";

        

        SPGridView1.Columns.Add(col);

        col = new SPBoundField();
        col.DataField = "Author";
        col.SortExpression = "Author";
        col.HeaderText = "Author";
        SPGridView1.Columns.Add(col);

        col = new SPBoundField();
        col.DataField = "Rating";
        col.SortExpression = "Rating";
        col.HeaderText = "Rating";
        SPGridView1.Columns.Add(col);

        Response.Write(SPGridView1.SortExpression);


        SPGridView1.AllowSorting = true;

        SPGridView1.AllowFiltering = true;

        SPGridView1.FilterDataFields = ",,Rating";

        //设置分组
        SPGridView1.AllowGrouping = true;
        SPGridView1.AllowGroupCollapse = true;
        SPGridView1.GroupField = "Title";
        SPGridView1.GroupDescriptionField = "Title";
        SPGridView1.GroupFieldDisplayName = "分组:";

        //添加下拉菜单字段
        SPMenuField colMenu = new SPMenuField();
        colMenu.HeaderText = "Presenter Name";
        colMenu.TextFields = "Title";

        //指定关联的菜单ID
        colMenu.MenuTemplateId = "PresenterListMenu";
        colMenu.NavigateUrlFields = "Title,Rating";
        colMenu.NavigateUrlFormat = "do.aspx?p={0}&q={1}";
        colMenu.TokenNameAndValueFields = "EDIT=Title,NAME=Rating";
        colMenu.SortExpression = "Title";

        //菜单
        MenuTemplate presenterListMenu = new MenuTemplate();
        presenterListMenu.ID = "PresenterListMenu";

        //菜单项
        MenuItemTemplate biogMenu = new MenuItemTemplate(
            "Read Biography", "/_layouts/images/EawfNewUser.gif");
        biogMenu.ClientOnClickNavigateUrl = "do.aspx?this=%EDIT%&that=%NAME%";
        //entry.ClientOnClickScript = "your javascript here";
        presenterListMenu.Controls.Add(biogMenu);

        //菜单项
        MenuItemTemplate broadcastMenu = new MenuItemTemplate(
                "Recent Broadcasts", "/_layouts/images/ICWM.gif");
        presenterListMenu.Controls.Add(broadcastMenu);

        //分割线
        MenuSeparatorTemplate sepMenu = new MenuSeparatorTemplate();
        presenterListMenu.Controls.Add(sepMenu);

        //菜单项
        MenuItemTemplate favMenu = new MenuItemTemplate(
               "Add to Favorites", "/_layouts/images/addtofavorites.gif");
        presenterListMenu.Controls.Add(favMenu);

        this.Controls.Add(presenterListMenu);
        SPGridView1.Columns.Add(colMenu);

        //绑定数据源
        this.SPGridView1.DataSourceID = "ExampleSource";
        this.SPGridView1.DataBind();             
    }

    public DataTable GetDataTable()
    {
        DataTable tblData = new DataTable();
        tblData.Columns.Add("Title");
        tblData.Columns.Add("Author");
        tblData.Columns.Add("Rating");

        tblData.Rows.Add("Obsession", "Robards, Karen", 2);
        tblData.Rows.Add("Vanished", "Robards, Karen", 3);
        tblData.Rows.Add("Magician: Apprentice", "Feist, Raymong E.", 4);
        tblData.Rows.Add("Magician: Master", "Feist, Raymong E.", 5);
        tblData.Rows.Add("Silverthorn", "Feist, Raymong E.", 4);
        tblData.Rows.Add("Lord Foul's Bane", "Donaldson, Stephen R.", 3);
        tblData.Rows.Add("The Illearth War", "Donaldson, Stephen R.", 4);

        return tblData;
    } 


}
